#!/usr/bin/env ruby

require 'sourcify'
require 'socket'
require 'json'

module Kernel
    def notify msg
        puts "notify #{msg}"
        $client.puts "NOTIFY:#{msg}"
    end

    def log msg
        puts "log"
        $client.puts "PUTS:#{msg}"
    end

end

module Ubiquity

    class Server
        def initialize port=1978
            @scope = {}
            server = TCPServer.new port
            puts "Ubiquity server listening on port 0.0.0.0:#{port}"
            $client = server.accept
            while line = $client.gets
                block = JSON.parse(line)
                c = eval(block["cmd"])
                c.call @scope, self
            end
            $client.close
        end


    end

    class Client
        def initialize remote_ip='localhost', port=1978
            @hooks = []
            @client = TCPSocket.new remote_ip, port
            Thread.new {
                while line = @client.gets
                    if line =~ /NOTIFY:(.+)/
                        notify_msg = $1.gsub("\n", "")
                        @hooks.each do |h|
                            if notify_msg == h[:hook]
                                h[:cb].call
                            end
                        end
                    elsif line =~ /PUTS:(.+)/
                        puts $1
                    end

                end
            }
        end

        def exec &block
            a = block.to_source
            @client.puts ({:cmd => a}.to_json)
        end

        def on msg, &block
            @hooks << {:hook => msg, :cb => block}
        end
    end

end

